"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var pluginName = 'modifiedAt';
// Does not support "$setOnInsert", "$min" and "$max".
var operators = ['$mul', '$inc', '$currentDate', '$set'];
var ModifiedAt = /** @class */ (function () {
    function ModifiedAt(schema, options) {
        this.schema = schema;
        this.options = options;
        this.schema = schema;
        this.options = options;
        this.initializeFieldSchema();
        this.addHooks();
    }
    ModifiedAt.prototype.addPathToSchema = function (pathname) {
        var _a;
        var select = this.options.select;
        this.schema.add((_a = {},
            _a[pathname] = { type: Date, select: select },
            _a));
    };
    ModifiedAt.prototype.initializeFieldSchema = function () {
        var _this = this;
        var _a = this.options, suffix = _a.suffix, fields = _a.fields, customList = _a.customList;
        // Add schema for every field
        lodash_1.forEach(fields, function (field) {
            _this.addPathToSchema(field + suffix);
        });
        // tslint:disable-next-line:variable-name
        lodash_1.forEach(customList, function (_value, pathname) {
            _this.addPathToSchema(pathname);
        });
    };
    ModifiedAt.prototype.setTimestamps = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, suffix, fields, customList, updatePaths, updateTime, _b, _c, _i, pathname, truly;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _a = this.options, suffix = _a.suffix, fields = _a.fields, customList = _a.customList;
                        updatePaths = [];
                        updateTime = new Date();
                        lodash_1.forEach(params.modifiedPaths, function (path) {
                            if (lodash_1.includes(fields, path)) {
                                updatePaths.push(path + suffix);
                            }
                        });
                        _b = [];
                        for (_c in customList)
                            _b.push(_c);
                        _i = 0;
                        _d.label = 1;
                    case 1:
                        if (!(_i < _b.length)) return [3 /*break*/, 4];
                        pathname = _b[_i];
                        if (!customList.hasOwnProperty(pathname)) return [3 /*break*/, 3];
                        return [4 /*yield*/, customList[pathname](params.doc)];
                    case 2:
                        truly = _d.sent();
                        if (truly) {
                            updateTime = new Date();
                            updatePaths.push(pathname);
                        }
                        _d.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4:
                        lodash_1.forEach(updatePaths, function (pathname) {
                            var _a;
                            switch (params.writingType) {
                                case 1:
                                    params.that.set(pathname, updateTime);
                                    break;
                                case 2:
                                    params.that.update({}, (_a = {}, _a[pathname] = updateTime, _a));
                                    break;
                                default:
                                    params.that[pathname] = updateTime;
                            }
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    ModifiedAt.prototype.addHooks = function () {
        var _this = this;
        var $this = this;
        // for Document
        this.schema.pre('save', function (next) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, $this.setTimestamps({
                                that: this,
                                doc: this,
                                modifiedPaths: this.modifiedPaths(),
                                writingType: 1,
                            })];
                        case 1:
                            _a.sent();
                            next();
                            return [2 /*return*/];
                    }
                });
            });
        });
        // for Query
        // prettier-ignore
        var updateHooks = ['findOneAndUpdate', 'update', 'updateOne', 'updateMany'];
        lodash_1.forEach(updateHooks, function (hook) {
            _this.schema.pre(hook, function (next) {
                return __awaiter(this, void 0, void 0, function () {
                    var updates;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (lodash_1.get(this.options, pluginName) === false) {
                                    return [2 /*return*/, next()];
                                }
                                updates = {};
                                lodash_1.forEach(this.getUpdate(), function (value, key) {
                                    if (lodash_1.includes(operators, key) && lodash_1.isPlainObject(value)) {
                                        lodash_1.assign(updates, value);
                                    }
                                    else {
                                        updates[key] = value;
                                    }
                                });
                                return [4 /*yield*/, $this.setTimestamps({
                                        that: this,
                                        doc: updates,
                                        modifiedPaths: lodash_1.keys(updates),
                                        writingType: 2,
                                    })];
                            case 1:
                                _a.sent();
                                next();
                                return [2 /*return*/];
                        }
                    });
                });
            });
        });
        // for Query
        this.schema.pre('replaceOne', function (next) {
            return __awaiter(this, void 0, void 0, function () {
                var updates_1, is$op_1, closedUpdates;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(lodash_1.get(this.options, pluginName) === true)) return [3 /*break*/, 2];
                            updates_1 = {};
                            is$op_1 = false;
                            lodash_1.forEach(this.getUpdate(), function (value, key) {
                                if (lodash_1.includes(operators, key) && lodash_1.isPlainObject(value)) {
                                    is$op_1 = true;
                                    lodash_1.assign(updates_1, value);
                                }
                                else {
                                    updates_1[key] = value;
                                }
                            });
                            closedUpdates = this.getUpdate();
                            if (is$op_1) {
                                if (!closedUpdates.$set) {
                                    closedUpdates.$set = {};
                                }
                                closedUpdates = closedUpdates.$set;
                            }
                            return [4 /*yield*/, $this.setTimestamps({
                                    that: closedUpdates,
                                    doc: updates_1,
                                    modifiedPaths: lodash_1.keys(updates_1),
                                })];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2:
                            next();
                            return [2 /*return*/];
                    }
                });
            });
        });
        // for Model
        // prettier-ignore
        // tslint:disable-next-line:only-arrow-functions
        this.schema.pre('insertMany', function (next, docs, opts) {
            return __awaiter(this, void 0, void 0, function () {
                var _i, docs_1, doc;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (lodash_1.get(opts, pluginName) === false) {
                                return [2 /*return*/, next()];
                            }
                            _i = 0, docs_1 = docs;
                            _a.label = 1;
                        case 1:
                            if (!(_i < docs_1.length)) return [3 /*break*/, 4];
                            doc = docs_1[_i];
                            return [4 /*yield*/, $this.setTimestamps({
                                    that: doc,
                                    doc: doc,
                                    modifiedPaths: lodash_1.keys(doc),
                                })];
                        case 2:
                            _a.sent();
                            _a.label = 3;
                        case 3:
                            _i++;
                            return [3 /*break*/, 1];
                        case 4:
                            next();
                            return [2 /*return*/];
                    }
                });
            });
        });
    };
    return ModifiedAt;
}());
function handleOptions(options) {
    var suffix = modifiedAt.suffix;
    var fields = [];
    var select = true;
    var customList = {};
    if (lodash_1.isArray(options)) {
        fields = options;
    }
    else if (lodash_1.isPlainObject(options)) {
        if (lodash_1.isString(options.suffix)) {
            suffix = options.suffix;
        }
        if (lodash_1.isBoolean(options.select)) {
            select = options.select;
        }
        if (lodash_1.isArray(options.fields)) {
            fields = options.fields;
        }
        lodash_1.forEach(lodash_1.omit(options, ['suffix', 'select', 'fields']), function (value, key) {
            if (lodash_1.isFunction(value)) {
                customList[key] = value;
            }
        });
    }
    else {
        throw Error('Missing options or type error of parameter "options".');
    }
    return { suffix: suffix, select: select, fields: fields, customList: customList };
}
function modifiedAt(schema, options) {
    return new ModifiedAt(schema, handleOptions(options));
}
modifiedAt.suffix = '_modifiedAt';
exports.default = modifiedAt;
